package me.zhengjie.modules.thirdparty.v1;

import cn.hutool.http.HtmlUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import me.zhengjie.annotation.Log;
import me.zhengjie.annotation.rest.AnonymousGetMapping;
import me.zhengjie.annotation.rest.AnonymousPostMapping;
import me.zhengjie.base.BaseResponse;
import me.zhengjie.base.QueryPageParams;
import me.zhengjie.modules.dm.user.service.DmUserService;
import me.zhengjie.modules.dm.user.service.dto.DmUserDto;
import me.zhengjie.modules.dm.user.service.dto.DmUserQueryCriteria;
import me.zhengjie.modules.system.service.DataService;
import me.zhengjie.modules.system.service.DeptService;
import me.zhengjie.modules.system.service.UserService;
import me.zhengjie.modules.system.service.dto.DeptDto;
import me.zhengjie.modules.system.service.dto.DeptQueryCriteria;
import me.zhengjie.modules.system.service.dto.DeptQueryNoAuthCriteria;
import me.zhengjie.utils.SecurityUtils;
import org.hibernate.Criteria;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

@RestController
@RequiredArgsConstructor
@Api(tags = "用户接口")
@RequestMapping("/api/thirdparty/v1/user")
public class UserApiController {
    private final DmUserService dmUserService;
    private final UserService userService;
    private final DataService dataService;
    private final DeptService deptService;

    @Log("获取ERP用户数据")
    @ApiOperation("获取ERP用户数据")
    @AnonymousGetMapping(value = "/busi/comm/usky/queryUser")
    public ResponseEntity<Object> getusers(HttpServletRequest request, String formData) throws IOException {
//        SecurityUtils.CheckApiAuth(request);
//        List<DmUserDto> list = dmUserService.queryAll(criteria);
        String res = HttpRequest.get("http://222.84.157.37:30170/api-third-party/busi/comm/usky/queryUser")
                .header("X_AUTO_USER_INFO_HEAD", "{\"id\":\"anonymous\",\"tenantId\":\"caih\"}")
                .body("{\n" +
                        "    \"formData\":{\n" +
                        "        \"pageNum\":1,\n" +
                        "        \"pageSize\":100\n" +
                        "    },\n" +
                        "    \"product\":\"17\",\n" +
                        "    \"sign\":\"e34b2f59-0e9d-45ed-a32a-f4abd4381000\"\n" +
                        "}").execute().body();
        JSONObject json = JSONObject.parseObject(res);
        return new ResponseEntity<>(json, HttpStatus.OK);
    }

    @Log("获取用户数据")
    @ApiOperation("获取用户数据")
    @AnonymousPostMapping(value = "/getzkusers")
    public BaseResponse<Object> getzkusers(@RequestBody QueryPageParams<DmUserQueryCriteria> params, Pageable pageable)  {
        SecurityUtils.CheckApiAuth(params);
        Map<String, Object> list = dmUserService.queryAll(params.getQuery(), pageable);

        return new BaseResponse<>(list);
    }

    @Log("获取部门数据")
    @ApiOperation("获取部门数据")
    @AnonymousPostMapping(value = "/getzkdeps")
    public BaseResponse<Object> getzkdeps(@RequestBody QueryPageParams<DeptQueryNoAuthCriteria> params, Pageable pageable) {
        SecurityUtils.CheckApiAuth(params);
        Map<String, Object> list = deptService.queryAll(params.getQuery(), pageable);

        return new BaseResponse<>(list);
    }
}